<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Teknisa\MAN\Services\RelDescConcedidos as RelDescService;
use Teknisa\MAN\Utilities;

//use Zeedhi\Framework\DataSource\FilterCriteria;

class RelDescConcedidos extends CrudWithParameterBag{

    const RELATORIO_POR_DIA_NAME = 'vnd55007_relDescConcedidos';
    const RELATORIO_SINTETICO    = 'vnd55007_relDescConcedidos_sintetico';
    
    protected $relDescService;
    protected $utilService;
    protected $dataSourceName;
    
    protected $parameterBagColumns = array('CDFILIAL', 'TIPORELATORIO');
    
    public function __construct (RelDescService $relDescService, Manager $dataSourceManager, ParameterBag $parameterBag, Utilities\Util $utilService) {
        parent::__construct($dataSourceManager, $parameterBag);
        $this->relDescService = $relDescService;
        $this->utilService = $utilService;
    }
    
    
    public function relDesconto(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);
        if($conditions['TIPORELATORIO'] == 'A'){
            $this->dataSourceName = self::RELATORIO_POR_DIA_NAME;
            parent::find($request, $response);
        }
        else{
            $this->dataSourceName = self::RELATORIO_SINTETICO;
            parent::find($request, $response);
        }
    }
}