<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager;

class SelectOperador extends CrudWithParameterBag {
    
    protected $dataSourceName = 'select_operador';
    protected $dataSourceNameComFilial = 'select_operador_por_filial';
    protected $dataSourceNameSemFilial = 'select_operador_sem_filial';
    protected $dataSourceNameSemNotIn = 'select_operador_not_in';
    protected $dataSourceOperadorByFilial = 'select_operador_mult_filial';

    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag) {
        parent::__construct($dataSourceManager, $parameterBag);
    }
    
    public function findOperadorByFilial($request, $response){
        $this->dataSourceName = $this->dataSourceOperadorByFilial;
        $this->parameterBagColumns = array('NRORG', 'CDFILIAL');
        parent::find($request,$response);
    }

    public function findSemFilial($request,$response) {
        $this->dataSourceName = $this->dataSourceNameSemFilial;
        $this->parameterBagColumns = array('NRORG', 'CDGRUPOPER');
        parent::find($request,$response);
    }

    public function findPorFilial($request,$response) {
        $this->dataSourceName = $this->dataSourceNameComFilial;
        
        parent::find($request,$response);
    }
    
    public function findNotIn($request,$response) {
        $this->dataSourceName = $this->dataSourceNameSemNotIn;
        $this->parameterBagColumns = array('NRORG', 'CDOPERADOR');
        parent::find($request,$response);
    }
}